LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY er_1octet IS
  PORT (
    rst : IN STD_LOGIC;
    clk : IN STD_LOGIC;
    en : IN STD_LOGIC;
    din : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
    miso : IN STD_LOGIC;
    sclk : OUT STD_LOGIC;
    mosi : OUT STD_LOGIC;
    dout : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
    busy : OUT STD_LOGIC;
    state : OUT NATURAL);
END er_1octet;

ARCHITECTURE behavioral_3 OF er_1octet IS
  TYPE t_etat IS (idle, bit_emis, bit_receptionne);
BEGIN PROCESS (clk, rst)
  VARIABLE cpt : NATURAL := 0;
  VARIABLE etat : t_etat := idle;
  VARIABLE registre : STD_LOGIC_VECTOR(7 DOWNTO 0) := "00000000";
BEGIN
  IF rst = '0' THEN
    cpt := 0;
    etat := idle;
    registre := "00000000";
    sclk <= '1';
    busy <= '0';
  ELSIF rising_edge(clk) THEN

    CASE etat IS
      WHEN idle =>
        IF en = '1' THEN
          registre := din;
          mosi <= registre(7);
          busy <= '1';
          sclk <= '0';
          cpt := 7;
          etat := bit_emis;
          state <= 1;
        END IF;

      WHEN bit_emis =>
        sclk <= '1';
        registre(cpt) := miso;
        etat := bit_receptionne;
        state <= 2;

      WHEN bit_receptionne =>
        IF cpt = 0 THEN
          busy <= '0';
          dout <= registre;
          etat := idle;
          state <= 0;
        ELSIF cpt > 0 THEN
          cpt := cpt - 1;
          sclk <= '0';
          mosi <= registre(cpt);
          etat := bit_emis;
          state <= 0;
        END IF;

    END CASE;
  END IF;
END PROCESS;
END behavioral_3;
